#!/bin/bash

# Copyright (C) 2018  Tetras Libre <Contact@Tetras-Libre.fr>
# Author: Beniamine, David <David.Beniamine@Tetras-Libre.fr>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

if [ -z "$1" ]
then
    echo "Usage $0 domain"
    exit 1
fi

PRODDIR="../prod"
DOMAIN=$1
rm cnames
cd `dirname $0`
OFS=$IFS
IFS=,
echo "name,email,username,password" > new_users.csv
while read name mail
do
    # Username = 1st letter of each name + lastname
    username=`echo $name | sed -e 's/\([a-zA-Z]\)[^ ]* /\1/g' \
        -e 's/^\(.*\)$/\L\1/'`

    # Generate random password
    IFS=$OFS
    password=`head /dev/urandom | tr -cd '[:alnum:]' | fold -w32 | head -n 1`
    IFS=,
    DST=$PRODDIR/$username

    # Prepare prod dir
    mkdir -p $DST
    cp docker-compose.yml $DST/
    sed -e "s/^\(DOMAIN=\).*$/\1$DOMAIN/" \
        -e "s/^\(VNCUSER=\).*$/\1$username/" \
        -e "s/^\(PASSWORD=\).*$/\1$password/" \
        .env.sample > $DST/.env
    echo "$name,$mail,$username,$password" >> new_users.csv
    echo "$username.$DOMAIN CNAME $DOMAIN" >> cnames

    # Launch instance
    cd $DST
    docker-compose up -d
    cd -

done < users.csv
IFS=$OFS

